
public class Main {

	public static void main(String[] args) {
		try {
			// création d'un Magasin: de 3 emplacements contenant un unique Objet à la troisième case
			Magasin magasin = new Magasin(3);
			magasin.place_objet(new Objet("Velo", 16), 2);
			
			// création d'un Drone, se déplaçant en volant et manipulant les Objets par magnetisme
			Robot drone = new Drone(magasin);
			drone.setModeDeDeplacement(new Voler());
			drone.setModeDeManipulation(new Magnetiser());
			
			// création d'un AutoTracteur, se déplaçant en roulant et manipulant les Objets par pincement
			Robot autotracteur = new AutoTracteur(magasin);
			autotracteur.setModeDeDeplacement(new Rouler());
			autotracteur.setModeDeManipulation(new Pincer());
			
			// déplacement de l’Objet de la troisième case à la seconde par le Drone:,
			System.out.println(magasin);
			drone.seDeplacerVersEmplacement(2);
			drone.captureObjet();
			drone.seDeplacerVersEmplacement(1);
			drone.liberationObjet();
			System.out.println(magasin);
			
			// déplacement de l’Objet de la seconde case à la première par l'AutoTracteur
			autotracteur.seDeplacerVersEmplacement(1);
			autotracteur.captureObjet();
			autotracteur.seDeplacerVersEmplacement(0);
			autotracteur.liberationObjet();
			System.out.println(magasin);
		} catch (RobotOccupeException e) {
			System.err.println(e);
		} catch (CaseVideException e) {
			System.err.println(e);
		} catch (CaseOccupeeException e) {
			System.err.println(e);
		}
	}

}
