
public abstract class Robot {
	private Integer numeroEmplacement ;
	private Objet objetPorte;
	private Magasin magasin;
	private ModeDeManipulation modeManipulation;
	private ModeDeDeplacement modeDeplacement;
	
	public Robot(Magasin mag) {
		this.magasin = mag;
		this.objetPorte = null;
		this.numeroEmplacement = 0 ;
	}
	
	public void seDeplacerVersEmplacement(Integer pos) {
		this.numeroEmplacement = pos;
		this.modeDeplacement.deplace(pos);
	}
	
	public void captureObjet() throws RobotOccupeException, CaseVideException {
		if (this.objetPorte != null) {
			throw new RobotOccupeException("Le robot ne peut capturer un objet.", this.objetPorte);
		}
		if ( this.magasin.getContenuEmplacement(this.numeroEmplacement) == null ) {
			throw new CaseVideException("Le robot ne peut capturer un objet", this.numeroEmplacement);
		}
		this.objetPorte = this.magasin.retire_objet(this.numeroEmplacement);
		this.modeManipulation.capture();
	}
	
	public void liberationObjet() throws CaseOccupeeException {
		if ( this.magasin.getContenuEmplacement(this.numeroEmplacement) != null ) {
			throw new CaseOccupeeException("Le robot ne peut libérer l'objet", this.numeroEmplacement);
		}
		this.magasin.place_objet(this.objetPorte, this.numeroEmplacement);
		this.objetPorte = null;
		this.modeManipulation.liberation();
	}
	
	public void setModeDeManipulation(ModeDeManipulation modeManip) {
		this.modeManipulation = modeManip;
	}
	
	public void setModeDeDeplacement(ModeDeDeplacement modeDepla) {
		this.modeDeplacement = modeDepla;
	}
	
	public abstract String toString();
}
